using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


namespace BA.WebPartLibrary
{
    public class WelComeWebPart : WebPart
    {

        private string _myNewProperty = "My New Property";
        [Personalizable( PersonalizationScope.User, false)]
        [WebBrowsable()]
        public string MyNewProperty
        {
            get { return _myNewProperty; }
            set { _myNewProperty = value; }
        }

        private bool _myNewDateProperty = true;
        [Personalizable(PersonalizationScope.User, false)]
        [WebBrowsable(),WebDisplayName("ShowDate")]
        public bool ShowDate
        {
            get { return _myNewDateProperty; }
            set { _myNewDateProperty = value; }
        }


        public WelComeWebPart()
        {
            this.Title = "Welcome";
            this.TitleUrl = "http://www.bennettadelson.com/net";
            this.HelpUrl = "http://www.bennettadelson.com";
        }

        public override WebPartVerbCollection Verbs
        {
            get
            {
                // Create SendEmail verb
                WebPartVerb verbSendEmail = new WebPartVerb("verbSendEmail", new WebPartEventHandler(EmailHandler));
                verbSendEmail.Text = "Send Email";
                verbSendEmail.Description = "Send your questions to Peruri Srinivasulu";
                verbSendEmail.ImageUrl = @"~\img\PERUSR.GIF";
                // Create collection of verbs
                WebPartVerb[] verbs = new WebPartVerb[] { verbSendEmail };
                // Return WebPartVerbCollection including base verbs
                return new WebPartVerbCollection(verbs);
            }
        }

        public void EmailHandler(Object s, WebPartEventArgs e)
        {
            Page.Response.Redirect("http://www.bennettadelson.com/Contact/index.aspx");
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            base.RenderContents(writer);
            string stringToRender = " Welcome to the ASP.NET 2.0 Web Parts session.";
            if (this.ShowDate)
                stringToRender  += DateTime.Now.ToString();
            writer.Write(stringToRender);

        }
    }

}
